> For the complete documentation index, see [llms.txt](https://docs.sannybuilder.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sannybuilder.com/edit-modes/migration-to-new-sbl-modes-in-sb4.md).

# Migration to new SBL modes in SB4

When converting code from old legacy modes based on INI with custom parameter order, keep in mind the following conventions used in new SBL modes (GTA III SBL, GTA VC SBL, GTA SA SBL):

* all params follow their original order, where output variables go after input arguments (`create_player 0 0 0 0 store_to $player1`)
  * SB4 provides special syntax, where outputs in an assignment expression can be listed on the left-hand side, e.g. `$player1 = create_player 0 0 0 0`)
* command name can be used instead of opcode (`shake_cam 100`)
* `Actor` is called `Char`
* `Marker` is called `Blip`
* `Model` class no longer exists, its methods can be found in static `Streaming` class
* `$PLAYER_CHAR` replaced with `$player1`
* `$PLAYER_ACTOR` replaced with `$scplayer`
* `angle` is called `heading`
* `thread` is called `script`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.sannybuilder.com/edit-modes/migration-to-new-sbl-modes-in-sb4.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
